<template>
	<div class="incubator lightestpink-color">
		<div class="header flex space">		
			<div class="node-info">
				<div class="flex space v-top">
					<div class="type hustle medium lightest-pink-color">{{getLocale('structure_main_incubator')}}</div>
					<div class="level medium-font">LV{{node.data.level}}</div>
				</div>
				
				<v-button 
					v-if="node.data.level < structureMaxLevel('incubator')"
					:text="getLocale('upgrade')"
					:secondary_text="structureUpgradeCost('incubator', node.data.level)"
					:icons="[ 'bytes_black.svg' ]"
					:disabled="checkStructureByteCost('incubator', node.data.level)"
					color="lightestpink"
					@clicked="upgradeNode(node.id)"
				/>
			</div>
			
			<div class="level-bar">
				<div class="bar">
					<div class="base lightestpink-bkg" :style="{width : (4*node.data.level)+'%'}"></div>
				</div>
				
				<div class="bonus" :class="{'active' : node.data.level >= 10}" :style="{left : '40%'}" v-tooltip="'incubator_perk_1'">
					<div class="icon lightestpink-border"></div>
					<div class="level bold">LV10</div>
					<div class="effect">{{getLocale('incubator_perk_1_label')}}</div>
				</div>
				
				<div class="bonus" :class="{'active' : node.data.level >= 20}" :style="{left : '80%'}" v-tooltip="'incubator_perk_2'">
					<div class="icon lightestpink-border"></div>
					<div class="level bold">LV20</div>
					<div class="effect">{{getLocale('incubator_perk_2_label')}}</div>
				</div>
			</div>
			
			<tutorial-icon color="#feb3ff" @clicked="setTutorial('incubator', -1, true)"/>
		</div>
	
		<div class="align-center">
			<div class="description">{{getLocale('structure_main_incubator_effect')}}</div>
		
			<div class="content special flex space v-top" :class="[current_process != null ? 'active green-border green-color' : 'lightestpink-border ']">
				<div class="top-section uppercase">
					<div v-if="assigned_vairus">
						<div v-if="assigned_vairus.level == 50">
							{{getLocale('vairus_max_level')}}
						</div>
						
						<div v-else class="flex space">
							<div>{{ parseTime(incubator_time*1000) }}</div>
							<div class="arrow">→</div>
							<div>LV <span class="bold">{{ assigned_vairus.level+1 }}</span></div>
						</div>
					</div>
				</div>
				
				<div class="action uppercase black-color bold" :class="{assigned : assigned_vairus}">
					<div v-if="assigned_vairus">
						<div v-if="current_process == null" class="start green-bkg" v-on:click="startIncubator">
							{{ getLocale('upgrade') }}
						</div>
						
						<div v-else class="stop lightestpink-bkg"  v-on:click="stopIncubator">
							{{ getLocale('cancel')}}
						</div>
					</div>
				</div>
				
				<div class="assignment">
					<div class="wrapper row-padding col-padding">
						<vairus-card 
							v-if="node.data.assignment"
							@clicked="requestList"
							:vairus="findVairus(node.data.assignment)"
							:highlighted="false"
							:show_footer="false"
							:hide_exhaustion="true"
							color="pink"
						/>
						
						<empty-card v-else @clicked="requestList" />
					</div>
					
					<img v-if="current_process" class="fluid" :style="{top : (80-current_process_percentage*0.8)+'%'}" v-bind:src="getImage('fluid.svg')" />
					<img v-if="current_process" class="fluid" :style="{top : (80-current_process_percentage*0.8)+'%'}" v-bind:src="getImage('fluid.svg')" />
				</div>
				
				<div class="bottom-section"></div>
				
				<v-info 
					class="efficiency" 
					:color="current_process == null ? '#FEB3FF' : '#00FFB4'" 
					:text="Math.floor(structureEffect('incubator', node.data.level)*100)+'%'" 
					v-tooltip="'main_efficiency_tooltip'"
				/>
				
				<v-info 
					v-if="current_process != null"
					class="time" 
					color="#00FFB4" 
					:text="parseTime(current_process.end*1000 - current_time)" 
				/>
			</div>
		</div>
	</div>
</template>


<script>
	import { commonMixin } from '../../mixins/common.js';
	import { structuresMixin } from '../../mixins/structures.js';
	import { storeGettersMixin } from '../../mixins/store_getters.js';
	import NumberChanger from '../NumberChanger.vue';
	import VButton from '../VButton.vue';
	import VInfo from '../VInfo.vue';
	import TutorialIcon from '../TutorialIcon.vue';
	import VairusCard from '../VairusCard.vue';
	import EmptyCard from '../EmptyCard.vue';
	import structuresManager from '../../classes/structuresManagerClass.js';
	
	var browser = browser || chrome;
	
	export default {
		props: ['node'],
		data: function () {
			return{
				
			}
		},
		methods: {
			parseTime(timestamp){
				console.log(timestamp);
				if(timestamp < 0) timestamp = 0;
			
				let d = Math.floor((timestamp / (1000 * 60 * 60 * 24)));
				timestamp -=  d*(1000 * 60 * 60 * 24);
				let h = Math.floor((timestamp / (1000 * 60 * 60)));
				let m = Math.floor((timestamp / (1000 * 60)) % 60);
				let s = Math.floor((timestamp / 1000) % 60);
				
				if(d > 0){
					return  d+'D '+h.toString().padStart(2, '0')+'H '+m.toString().padStart(2, '0')+'M';
				}
				
				if(h > 0){
					return  h.toString().padStart(2, '0')+'H '+m.toString().padStart(2, '0')+'M '+s.toString().padStart(2, '0')+'S';
				}
				
				return m.toString().padStart(2, '0')+'M '+s.toString().padStart(2, '0')+'S';
			},
			startIncubator(){
				if(this.start_process_lock) return;
				this.$store.commit('setActionLock', 'start_process_lock');
				
				browser.runtime.sendMessage({
					type : 'start_node_process',
					data : { 
						node_id : this.node.id.replace('n', ''),
						type : 'incubator',
						cycle : 1
					}
				});
			},
			stopIncubator(){
				if(this.current_process != null){
					browser.runtime.sendMessage({
						type : 'stop_process',
						data : this.current_process.id
					});
				}
			},
			requestList(){
				if(this.current_process != null){
					if(confirm(this.getLocale('stop_process_warning'))){
						this.$emit('requestlist');
					}
				}else{
					this.$emit('requestlist');
				}
			}
		},
		computed: {
			assigned_vairus(){
				let vairus = this.vairus_list.find(function(v){
					return v.unique_id == this.node.data.assignment;
				}.bind(this));
				
				return (typeof vairus !== 'undefined') ? vairus : null;
			},
			current_process(){
				if(this.node.data.assignment == null) return null;
				
				let process = this.processes.find(function(p){
					return p.vairus_id == this.node.data.assignment;
				}.bind(this));
				
				return (typeof process !== 'undefined') ? process : null;
			},
			incubator_time(){
				let to_level = this.assigned_vairus.level+1;
				let progress_required = to_level*100;
				
				if(to_level%10 == 0){
					let penality = (this.node.data.level >= 20) ? 5 : 10;
					progress_required = progress_required * penality;
				}
				
				let incubator_efficacy = this.structureEffect('incubator', this.node.data.level);
				incubator_efficacy = Math.round(incubator_efficacy*100);
				
				return Math.round((progress_required/incubator_efficacy)*3600);
			},
			current_process_percentage(){
				if(this.current_process == null) return 0;
				
				let total = this.current_process.end - this.current_process.start;
				let current = (this.current_time/1000) - this.current_process.start;
				
				return (100*current) / total;
			}
		},
		mixins: [commonMixin, structuresMixin, storeGettersMixin],
		components: {
			NumberChanger, VButton, VInfo, VairusCard, EmptyCard, TutorialIcon
		}
	}
</script>


<style lang="scss" scoped>

	.incubator{
		.description{
			text-align: left;
			position: absolute;
			width: 200px;
		}
		.top-section div{
			white-space: nowrap;
		}
		
		.fluid{
			position: absolute;
			width: 500px;
			height: 500px;
			left: -87.5px;
			animation: fluid 10s ease-in-out infinite;
			
			&:last-child{
				animation-delay: -7s;
			}
		}
		@media screen and (max-width: 800px) {
			.description{
				width: 100%;
				text-align: right;
				right: 25px;
			}	
			.content{
				margin-top: 50px !important;
			}
		}	
		
		@media screen and (max-width: 700px) {
			.level-bar{
				display: none;
			}
			.header {
				margin-bottom: -20px !important;
			}
		}
		@media screen and (max-width: 400px) {
			.vairus-card{
				width: 175px;
				height: 250px;
			}
		}
	}
	
	@keyframes fluid{
		0%{
			transform: translate(-87.5px, 10px);
		}
		50%{
			transform: translate(87.5px, -10px);
		}
		100%{
			transform: translate(-87.5px, 10px);
		}
	}

</style>








